<?php

class configure {

	public $list;

	public function __construct(&$list){
		$this->list = &$list;
	}

	public function get_vars_table_markup($only_inside=false, $message=""){
		$tmp = env::$db->query("SELECT id, config_name, config_value, type FROM config.t_global ORDER BY 2");
		$table_markup = env::$db->get_yui_table("vars", array(
			'width' => 670,
			'formatters' => array(
				'config_name' => "custom:el.innerHTML=(oRecord.getData('id')!='') ?oData ".
					":'<input type=text value=\''+oData+'\' size=15 onblur=\'var r=dt_vars.getRecord(this);".
					"r.setData(\"config_name\",this.value);\'/>'",
				'config_value' => "custom:el.innerHTML='<input type=text value=\''+oData+'\' size=20 onblur=\'var r=dt_vars.getRecord(this);".
					"if(r.getData(\"type\")==\"number\" && isNaN(this.value)) this.value=r.getData(\"config_value\");".
					"else r.setData(\"config_value\",this.value);".
					"\'/>'",
				'type' => "custom:el.innerHTML=(oRecord.getData('id')!='') ?oData ".
					":('<select onchange=\'dt_vars.getRecord(this).setData(\"type\",this.value);\'>".
					"<option value=text'+(oData=='text'?' selected=selected':'')+'>text</option>".
					"<option value=number'+(oData=='number'?' selected=selected':'')+'>number</option></select>');",
			),
			'format_col_heads' => "replace:_: |ucfirst",
			'template' => "yui_datatable_confv.tpl",
			'allow_insdel' => true,
			'nopaginator' => true,
			'only_inside' => $only_inside,
			'message' => $message,
			'editable' => true,
		));
		return $table_markup;
	}

	public function get_instances_table_markup($only_inside=false, $message=""){
		$versions = env::sget_conf("allowed_pg_versions");
		$version_opts = "";
		foreach ($versions as $v){
			$version_opts .= "<option value=\'{$v}\''+('{$v}'==oData?' selected=\'selected\'':'')+'>{$v}</option>";
		}
		$tmp = env::$db->query("SELECT id,descr,hostname,port,version FROM config.t_node ORDER BY descr");
		$table_markup = env::$db->get_yui_table("instances", array(
			'width' => 670,
			'reversed' => false,
			'formatters' => array(
				'hostname' => "custom:el.innerHTML='<input type=text value=\''+oData+'\' size=15 onblur=\'var r=dt_instances.getRecord(this);".
					"r.setData(\"hostname\",this.value);\'/>'",
				'port' => "custom:el.innerHTML='<input type=text value=\''+oData+'\' size=5 onblur=\'var r=dt_instances.getRecord(this);".
					"if(isNaN(this.value)) this.value=r.getData(\"port\");".
					"else r.setData(\"port\",this.value);".
					"\'/>'",
				'descr' => "custom:el.innerHTML='<input type=text value=\''+oData+'\' size=10 onblur=\'var r=dt_instances.getRecord(this);".
					"r.setData(\"descr\",this.value);\'/>'",
				'version' => "custom:el.innerHTML='<select onblur=\'var r=dt_instances.getRecord(this);".
					"r.setData(\"version\",this.value);\'>{$version_opts}</select>';",
			),
			'format_col_heads' => "replace:_: |ucfirst",
			'col_heads' => array(
				'descr' => "Description",
			),
			'allow_insdel' => true,
			'nopaginator' => true,
			'only_inside' => $only_inside,
			'message' => $message,
			'autorun_js' => "if (typeof autorun != 'undefined') autorun();",
			'template' => "yui_datatable_confi.tpl",
			'editable' => true,
		));
		return $table_markup;
	}

	public function get_databases_table_markup($node_id, $only_inside=false, $message=""){
		$node_id = 1 * $this->list['node_id'];
		$tmp = env::$db->query("SELECT id, database_name, connect_string, node_id ".
			"FROM config.t_database WHERE node_id={$node_id} ORDER BY database_name");
		$table_markup = env::$db->get_yui_table("databases", array(
			'width' => 630,
			'formatters' => array(
				'database_name' => "custom:el.innerHTML='<input type=text value=\''+oData+'\' size=10 onblur=\'var r=dt_databases.getRecord(this);".
					"r.setData(\"database_name\",this.value);\'/>'",
				'connect_string' => "custom:el.innerHTML='<input type=text value=\''+oData+'\' style=\'width:300px\' onblur=\'var r=dt_databases.getRecord(this);".
					"r.setData(\"connect_string\",this.value);\' title=\"Sample: \\'host=localhost port=5432 user=postgres password=mypass\\'\"/>'",
			),
			'format_col_heads' => "replace:_: |ucfirst",
			'hidden_cols' => array( "node_id" ),
			'allow_insdel' => true,
			'nopaginator' => true,
			'only_inside' => $only_inside,
			'message' => $message,
			'template' => "yui_datatable_confd.tpl",
			'editable' => true,
		));
		return $table_markup;
	}

	public function display(){
		$func = isset($this->list['func']) ?$this->list['func'] :"";
		switch ($func){
		case "":
			// env::$smarty->assign("vars_markup", $this->get_vars_table_markup());
			env::$smarty->assign("instances_markup", $this->get_instances_table_markup());
			env::$smarty->display("configure.tpl");
			return;
		case "vars":
			echo $this->get_vars_table_markup();
			return;
		case "vars-save":
			if ($this->list['id'] == ""){
				$tmp = env::$db->query_params("INSERT INTO config.t_global (config_name, config_value,type) VALUES ($1,$2,$3)",
					array($this->list['config_name'], $this->list['config_value'], $this->list['type']));
			}else{
				$tmp = env::$db->query_params("UPDATE config.t_global SET (config_name, config_value,type)=($1,$2,$3) WHERE id=$4",
					array($this->list['config_name'], $this->list['config_value'], $this->list['type'], $this->list['id']));
			}
			if (!$tmp) return false;
			echo $this->get_vars_table_markup(true, _("Saved."));
			return;
		case "vars-delete":
			if (is_numeric($this->list['id'])){
				$tmp = env::$db->query_params("DELETE FROM config.t_global WHERE id=$1", array($this->list['id']));
				if (!$tmp) return false;
			}
			echo $this->get_vars_table_markup(true, _("Deleted."));
			return;
		case "dbs":
			env::$smarty->assign("instances_markup", $this->get_instances_table_markup());
			env::$smarty->display("configure-dbs.tpl");
			return;
		case "dbs-instances-load":
			echo $this->get_instances_table_markup(true);
			return;
		case "dbs-databases-load":
			echo $this->get_databases_table_markup(true);
			return;
		case "instances-save":
			if ($this->list['id'] == ""){
				$tmp = env::$db->query_params("INSERT INTO config.t_node (hostname,descr,version,port) VALUES ($1,$2,$3,$4)",
					array($this->list['hostname'], $this->list['descr'], $this->list['version'], 1 * $this->list['port']));
			}else{
				$tmp = env::$db->query_params("UPDATE config.t_node SET (hostname,descr,version,port)=($1,$2,$3,$4) WHERE id=$5",
					array($this->list['hostname'], $this->list['descr'], $this->list['version'], 1 * $this->list['port'], $this->list['id']));
			}
			if (!$tmp) return false;
			echo $this->get_instances_table_markup(true, _("Saved."));
			return;
		case "instances-delete":
			if (is_numeric($this->list['id'])){
				$tmp = env::$db->query_params("DELETE FROM config.t_node WHERE id=$1", array($this->list['id']));
				if (!$tmp) return false;
			}
			echo $this->get_instances_table_markup(true, _("Deleted."));
			return;
		case "databases-save":
			if ($this->list['id'] == ""){
				$tmp = env::$db->query_params("INSERT INTO config.t_database (node_id,database_name,connect_string) VALUES ($1,$2,$3)",
					array($this->list['node_id'], $this->list['database_name'], $this->list['connect_string']));
			}else{
				$tmp = env::$db->query_params("UPDATE config.t_database SET (node_id,database_name,connect_string)=($1,$2,$3) WHERE id=$4",
					array($this->list['node_id'], $this->list['database_name'], $this->list['connect_string'], $this->list['id']));
			}
			if (!$tmp) return false;
			echo $this->get_databases_table_markup(true, _("Saved."));
			return;
		case "databases-delete":
			if (is_numeric($this->list['id'])){
				$tmp = env::$db->query_params("DELETE FROM config.t_database WHERE id=$1", array($this->list['id']));
				if (!$tmp) return false;
			}
			echo $this->get_databases_table_markup(true, _("Deleted."));
			return;
		case "databases-test":
			env::$halt_on_error = false;
			$conn = pg_connect($this->list['connect_string']);
			if ($conn){
				echo _("Connection works!");
			}else{
				echo _("Wrong connect string!");
			}
			return;
		}
	}

}

	?>