<?php

class dates {

	public $date_from;
	public $date_until;
	public $ts_from;
	public $ts_until;
	public $dates_in_url;
	public $granularity;
	public $step;
	public $date_pattern;
	public $date_pattern_day;
	public $gran;
	public $points_max;
	public $gap;

	function __construct(&$list, $shift_start=0){
		if (isset($_SESSION['date_from']) && $_SESSION['date_from']!="")
			$this->date_from = $_SESSION['date_from'];
		if (isset($list['date_from']) && $list['date_from']!="")
			$this->date_from = $list['date_from'];
		if (!$this->date_from)
			$this->date_from = strftime("%Y-%m-%d", time() - 30*86400);
		if (isset($_SESSION['date_until']) && $_SESSION['date_until']!="")
			$this->date_until = $_SESSION['date_until'];
		if (isset($list['date_until']) && $list['date_until']!="")
			$this->date_until = $list['date_until'];
		if (!$this->date_until)
			$this->date_until = strftime("%Y-%m-%d");
		$_SESSION['date_from'] = $this->date_from;
		$_SESSION['date_until'] = $this->date_until;
		$this->dates_in_url = "date_from={$this->date_from}&date_until={$this->date_until}";
		env::$smarty->assign('date_from', $this->date_from);
		env::$smarty->assign('date_until', $this->date_until);
		$a_from = explode("-", $this->date_from)+array(null,null,null);
		$a_until = explode("-", $this->date_until)+array(null,null,null);
		$a_today = explode("-", strftime("%Y-%m-%d"))+array(null,null,null);
		$this->ts_from = mktime(0,0,0,$a_from[1],$a_from[2],$a_from[0]);
		$this->ts_until = mktime(0,0,0,$a_until[1],$a_until[2],$a_until[0]);
		$today = mktime(0,0,0,$a_today[1],$a_today[2],$a_today[0]);
		env::$smarty->assign("diff_from", floor(($this->ts_from - $today) / 86400));
		env::$smarty->assign("diff_until", floor(($this->ts_until - $today) / 86400));

		$db = new pgwatch_database(env::$db->dbconn);
		$this->points_max = env::sget_conf("chart_points_max");

		$this->gran = $this->get_granularity_subquery($shift_start);

		$this->gap = $this->step . " " . $this->granularity;
	}

	public function calculate_granularity(){
		$diff = $diff_orig = ($this->ts_until - $this->ts_from) / 3600; // difference in hours
		$this->granularity = 'hour';
		$this->date_pattern = 'YYYY-MM-DD HH24"h"';
		$this->date_pattern_day = 'YYYY-MM-DD';
		$this->step =  1; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  2; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  3; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  4; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  6; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  8; if ($diff/$this->step <= $this->points_max) return;
		$this->step = 10; if ($diff/$this->step <= $this->points_max) return;
		$this->step = 12; if ($diff/$this->step <= $this->points_max) return;
		$this->granularity = 'day';
		$this->date_pattern_day = $this->date_pattern = 'YYYY-MM-DD';
		$diff = $diff_orig/24;
		$this->step =  1; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  2; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  3; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  4; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  5; if ($diff/$this->step <= $this->points_max) return;
		$this->granularity = 'week';
		$this->date_pattern_day = $this->date_pattern = 'YYYY-MM-DD';
		$diff = $diff_orig/24/7;
		$this->step =  1; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  2; if ($diff/$this->step <= $this->points_max) return;
		$this->granularity = 'month';
		$this->date_pattern_day = $this->date_pattern = 'YYYY-MM';
		$diff = $diff_orig/24/30;
		$this->step =  1; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  2; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  3; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  4; if ($diff/$this->step <= $this->points_max) return;
		$this->step =  6; if ($diff/$this->step <= $this->points_max) return;
		$this->granularity = 'year';
		$this->date_pattern_day = $this->date_pattern = 'YYYY';
		$this->step =  1; return;
	}

	public function get_granularity_subquery($shift_start=0){
		$this->calculate_granularity();
		$g = $this->granularity;
		$s = $this->step;
		$sp1 = $this->step+1;
		$s2 = $s/2;
		$p = $this->date_pattern;
		$pd = $this->date_pattern_day;
		$d1 = $this->date_from;
		$d2 = $this->date_until;
		if ($shift_start == 0){
			$sql = "SELECT ".
				"to_char(d, '{$p}') AS date_a, ".
				"to_char(d+'{$s} {$g}'::interval, '{$p}') AS date_b, ".
				"d AS date_a2, ".
				"(d+'{$s} {$g}'::interval) AS date_b2, ".
				"to_char(d+'{$s2} {$g}'::interval, '{$p}') AS date_m ".
				"FROM (SELECT * FROM generate_series(".
				"'{$d1}'::timestamp, '{$d2}'::timestamp+'1 day'::interval, '{$s} {$g}'::interval".
				") AS d) AS x";
		}else{
			$shift_amount = $s * $shift_start;
			$sql = "SELECT ".
				"to_char(d, '{$p}') AS date_a, ".
				"to_char(d+'{$s} {$g}'::interval, '{$p}') AS date_b, ".
				"d AS date_a2, ".
				"(d+'{$s} {$g}'::interval) AS date_b2, ".
				"to_char(d+'{$s2} {$g}'::interval, '{$p}') AS date_m ".
				"FROM (SELECT * FROM generate_series(".
				"'{$d1}'::timestamp-'{$shift_amount} {$g}'::interval, ".
				"least('{$d2}'::timestamp+'1 day'::interval, (SELECT tstamp FROM log.t_sync ORDER BY id DESC LIMIT 1)), ".
				"'{$s} {$g}'::interval".
				") AS d) AS x";
		}
		return $sql;
	}

}

?>
